namespace projectDoubleDeckerBus
{
    public partial class FormDoubleDeckerBus : Form
    {
        private DrawningDoubleDeckerBus? _drawningDoubleDeckerBus;
        public FormDoubleDeckerBus()
        {
            InitializeComponent();
        }

        private void Draw()
        {
            if (_drawningDoubleDeckerBus == null)
            {
                return;
            }
            Bitmap bmp = new(pictureBoxDoubleDeckerBus.Width,
            pictureBoxDoubleDeckerBus.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawningDoubleDeckerBus.DrawTransport(gr);
            pictureBoxDoubleDeckerBus.Image = bmp;
        }
        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            Random random = new();
            _drawningDoubleDeckerBus = new DrawningDoubleDeckerBus();
            _drawningDoubleDeckerBus.Init(random.Next(100, 300),
            random.Next(1000, 3000),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256),
            random.Next(0, 256)),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256),
            random.Next(0, 256)),
            Convert.ToBoolean(random.Next(0, 2)),
            Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)),

            pictureBoxDoubleDeckerBus.Width, pictureBoxDoubleDeckerBus.Height);
            _drawningDoubleDeckerBus.SetPosition(random.Next(10, 100),
            random.Next(10, 100));
            Draw();

        }

        private void ButtonMove_Click(object sender, EventArgs e)
        {
            if (_drawningDoubleDeckerBus == null)
            {
                return;
            }
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _drawningDoubleDeckerBus.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _drawningDoubleDeckerBus.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _drawningDoubleDeckerBus.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _drawningDoubleDeckerBus.MoveTransport(Direction.Right);
                    break;
            }
            Draw();

        }
      
    }
}